# FOR NO CONDITIONAL GENERATION ABLATION STUDY

i2i_generate_child_no_exp = lambda prev_qs, convo_history, bug_fixes, bug_description, target: f"""
Based on the student's current level of understanding, as demonstrated through their conversation history (tag "conversation_history"), what is 1 follow-up question with increasing depth and difficulty RELATIVE to the 'previous_questions' that you could ask based on the Student's explanation that would help them reach the "target_understanding"?

---
target_understanding: {target}
---

conversation_history:
{convo_history}

previous_questions: 
{prev_qs}

These questions should help the Student arrive at the answer themselves; do NOT give any direct hints towards the solution (under tag "bug_fixes" and tag "bug_description").

{bug_fixes}

{bug_description}

Make sure your questions are focused on the below "target_understanding".
---
target_understanding: {target}
---

Generate your question where it leads the Student to reach the "target_understanding". Ensure that the depth and difficulty of your new questions are increased compared to the previous questions asked (tag "previous_questions"):

"""

i2i_generate_sibling_no_exp = lambda prev_qs, convo_history, bug_fixes, bug_description, target: f"""
Based on the student's current level of understanding, as demonstrated through their conversation history (tag "conversation_history"), what is 1 follow-up question with the same level of depth and difficulty RELATIVE to the 'previous_questions' that you could ask based on the Student's explanation that would help them reach the "target_understanding"?
You must generate a question such that any correct answer to your question should automatically reflect the "target_understanding".

---
target_understanding: {target}
---

conversation_history:
{convo_history}

previous_questions: 
{prev_qs}

These questions should help the Student arrive at the answer themselves; do NOT give any direct hints towards the solution (under tag "bug_fixes" and tag "bug_description").

{bug_fixes}

{bug_description}

Make sure your questions are focused on the below "target_understanding".
---
target_understanding: {target}
---

Generate your question where it leads the Student to reach the "target_understanding". Ensure that the depth and difficulty of your new question is the same or less than the previous questions asked (tag "previous_questions"):
"""


# FOR NO STATE ABLATION STUDY

yaml_instructor_answer = """
Answer the above "question" only. 

Format your answer as "instructor_answer" in the following YAML format. Add your "instructor_answer" right after the colon without a newline. Do not generate or output any code in your answer, please - keep your answer in English only:
---
instructor_answer: <instructor answer to "question">
---
"""

yaml_cqg_no_state = """
$k$ is the number of questions you can ask the Student. Format the questions in the following YAML format. Add each question right after the colon without a newline:
---
question_1: <generate question_1>
question_2: <generate question_2>
...
question_k: <generate question_k>
---
"""

i2i_generate_initial_q_no_state = lambda bug_fixes, bug_description, remaining_bugs: f"""
Based on the buggy code, what is one question (k=1) that you could ask to help the Student correct their bugs (tag "remaining_bugs")? 
These questions should help the Student arrive at the answer themselves; do NOT give any direct hints towards the solution (after tag 'bug_fixes').

These questions should help the Student arrive at the answer themselves; do NOT give any direct hints towards the solution (under tag "bug_fixes" and tag "bug_description").

{bug_fixes}

{bug_description}

---
remaining_bugs:
{remaining_bugs}
---
"""


i2i_generate_child_no_state = lambda prev_qs, convo_history, bug_fixes, bug_description, remaining_bugs: f"""
Based on the student's current level of understanding, as demonstrated through their conversation history (tag "conversation_history"), what is 1 follow-up question with increasing depth and difficulty RELATIVE to the 'previous_questions' that you could ask based on the Student's explanation that would help them correct their remaining bugs (tag "remaining_bugs")?

conversation_history:
{convo_history}

previous_questions: 
{prev_qs}

remaining_bugs:
{remaining_bugs}

These questions should help the Student arrive at the answer themselves; do NOT give any direct hints towards the solution (under tag "bug_fixes" and tag "bug_description").

{bug_fixes}

{bug_description}

Generate your question where it leads the Student to correct their remaining bugs. Ensure that the depth and difficulty of your new questions are increased compared to the previous questions asked (tag "previous_questions"):

"""

i2i_generate_sibling_no_state = lambda prev_qs, convo_history, bug_fixes, bug_description, explanations: f"""
Based on the student's current misunderstanding of the previous question, as demonstrated through the reason why they got the previous question incorrect ("") and their conversation history (tag "conversation_history"), what is 1 follow-up question with the same level of depth and difficulty RELATIVE to the 'previous_questions' that you could ask based on the Student's explanation that would help them correct their bugs? Make sure that the question addresses the reasons why the Student got the previous question(s) wrong, as detailed in tag "misunderstanding", such that the Student is more likely to resolve these misunderstandings.

conversation_history:
{convo_history}

previous_questions: 
{prev_qs}

misunderstanding:
{explanations}

These questions should help the Student arrive at the answer themselves; do NOT give any direct hints towards the solution (under tag "bug_fixes" and tag "bug_description").

{bug_fixes}

{bug_description}

Generate your question where it leads the Student to correct their bugs. Ensure that the depth and difficulty of your new question is the same or less than the previous questions asked (tag "previous_questions"):
"""


i2i_generate_teaching_no_state = lambda q, bug_fixes, bug_description: f"""Below you are given 'buggy_code'. Here are some corresponding 'bug_fixes' and 'bug_descriptions' that will fix the 'buggy_code' when applied:

{bug_fixes}

{bug_description}

Can you please provide an appropriate response to this question: {q}\n""" + yaml_instructor_answer